# 
#	FOLLOWING ROUTINES ARE USER WRITTEN ROUTINES. THESE 
#	ROUTINES THE USER HAS TO INSERT INTO THE LIST
#
#	USER ROUTINES		CALLED BY
#	alb1.cpp		exalg.cpp
#	alb2.cpp		exalg.cpp
#	alb3.cpp		exalg.cpp
#	alb4.cpp		exalg.cpp
#	alb5.cpp		exalg.cpp
#	alp1.cpp		exalg.cpp
#	alp2.cpp		exalg.cpp
#	alp3.cpp		exalg.cpp
#	alp4.cpp		exalg.cpp
#	alp5.cpp		exalg.cpp
#	crset.cpp		xalg1.cpp
#	dset.cpp		xalg8.cpp
#	rset.cpp		xalg1.cpp
#	seset.cpp		xalg8.cpp
#	sset.cpp		xalg8.cpp
#	trm1.cpp		exalg.cpp
#	trm2.cpp		exalg.cpp
#	tset.cpp		xalg1.cpp
#	uerror.cpp		xalg8.cpp, costfn.cpp, deset.cpp, mtamxp.cpp, mtamx.cpp 
#

SNARK14ROOT=../../..

ifndef XERCESLIBDIR
XERCESLIBDIR = /usr/lib
endif

ifndef XERCESLIB
XERCESLIB = xerces-c
endif

ifndef XERCESINCLUDE
XERCESINCLUDE = /usr/include/xercesc
endif

ifndef DIGLIBDIR
DIGLIBDIR = /usr/lib
endif

ifndef DIGFILELIB
DIGFILELIB = DIGFile
endif

ifndef DIGFILEINCLUDE
DIGFILEINCLUDE = /usr/include/DIGFile
endif

ifndef DIGFILESNARKLIB
DIGFILESNARKLIB = DIGFileSnark
endif

ifndef DIGFILESNARKINCLUDE
DIGFILESNARKINCLUDE = /usr/include/DIGFileSnark
endif

ifndef DIGRANDLIB
DIGRANDLIB = DIGRand
endif

ifndef DIGRANDINCLUDE
DIGRANDINCLUDE = /usr/include/DIGRand
endif

ifndef CXX
CXX=g++
endif

#ifndef CC
CC=gcc
#endif

ifndef CXXFLAGS
CXXFLAGS=-g -std=c++98
endif

#ifndef CFLAGS
CFLAGS=-g -std=c99 -D_GNU_SOURCE
#endif

OUTDIR=$(SNARK14ROOT)/bin

LIBDIR=$(SNARK14ROOT)/lib

INCLUDEDIR = \
	-I/usr/include \
	-I$(XERCESINCLUDE)/.. \
	-I$(DIGFILEINCLUDE) \
	-I$(DIGFILESNARKINCLUDE) \
	-I$(DIGRANDINCLUDE) \
	-I$(SNARK14ROOT)/src/snark \
	
SRCDIR=$(SNARK14ROOT)/src/snark

OBJ = \
	alg.o \
	alb1.o \
	alb2.o \
	alb3.o \
	alb4.o \
	alb5.o \
	alp1.o \
	alp2.o \
	alp3.o \
	alp4.o \
	alp5.o \
	anglst.o \
	art.o \
	art_artbck.o \
	art_bkproj.o \
	art_clip.o \
	art_crset.o \
	art_readin.o \
	art_rset.o \
	art_tset.o \
	back.o \
	basis.o \
	bbldlst.o \
	bckprj.o \
	bdhk.o \
	bdhk_misl.o \
	bh_correction.o \
	bldlst.o \
	blkdta.o \
	blob.o \
	blob_bpix.o \
	blob_footp.o \
	blob_functions.o \
	blob_setparam.o \
	blob_table.o \
	blob2pix.o \
	bpseudo.o \
	bray.o \
	bsmooth.o \
	bwray.o \
	chtoin.o \
	cin.o \
	congeo.o \
	consts.o \
	contur.o \
	conv.o \
	creacm.o \
	creaer.o \
	creaph.o \
	creapr.o \
	creatr.o \
	dcon.o \
	dcon_dconbl.o \
	dcon_dconft.o \
	disp.o \
	disply.o \
	dist.o \
	doline.o \
	effpick.o \
	emap.o \
	emap_CEvalMAP.o \
	emap_CInitMAP.o \
	emap_CMAP.o \
	emap_CReadInp.o \
	emap_Cwray.o \
	emap_sscal.o \
	err.o \
	errfac.o \
	errpar.o \
	eval.o \
	exalg.o \
	fft2p.o \
	file11.o \
	foru.o \
	foru_bckwrd.o \
	foru_error.o \
	foru_fft.o \
	foru_forwrd.o \
	foru_frfilt.o \
	foru_frinit.o \
	foru_ftfill.o \
	foru_ftmap.o \
	foru_intrpl.o \
	foru_prjtrn.o \
	foru_store.o \
	foru_uint.o \
	foru_unif.o \
	foru_vc56.o \
	foru_vcase1.o \
	foru_vcase2.o \
	foru_vcase3.o \
	foru_vcase4.o \
	foru_vint14.o \
	fourie.o \
	ftodd.o \
	geom.o \
	getang.o \
	getden.o \
	getint.o \
	getnum.o \
	getnxt.o \
	getwrd.o \
	halft.o \
	imagewise_roi.o\
	infile.o \
	inputfile.o \
	int2str.o \
	lines.o \
	lino.o \
	lino_czt.o \
	lino_sumfac.o \
	main.o \
	mart.o \
	mode.o \
	modefl.o \
	noise.o \
	objects.o \
	pick.o \
	pix2blob.o \
	pnch.o \
	pnchfile.o \
	point.o \
	posit.o \
	post.o \
	prdta.o \
	primfc.o \
	projfile.o \
	pseudo.o \
	qfilt.o \
	qinit.o \
	qintp.o \
	quad.o \
	quad_adsmos.o \
	quad_back.o \
	quad_badsmos.o \
	quad_blurck.o \
	quad_bprpict.o \
	quad_costfn.o \
	quad_deltac.o \
	quad_deltad.o \
	quad_deset.o \
	quad_dset.o \
	quad_eigval.o \
	quad_matrix.o \
	quad_mtamx.o \
	quad_mtamxp.o \
	quad_nextr.o \
	quad_nxtpct.o \
	quad_prpict.o \
	quad_prsemi.o \
	quad_resedu.o \
	quad_semi.o \
	quad_seset.o \
	quad_sset.o \
	quad_uerror.o \
	ray.o \
	raylen.o \
	raysel.o \
	rdpict.o \
	rdproj.o \
	recfile.o \
	region.o \
	rfl.o \
	rtfort.o \
	second.o \
	select.o \
	settra.o \
	sinc.o \
	sirt.o \
	smooth.o \
	snark.o \
	snfft.o \
	spctrm.o \
	stopex.o \
	subreg.o \
	term.o \
	termtest.o \
	transm.o \
	trm1.o \
	trm2.o \
	trm3.o \
	uiod.o \
	unkps.o \
	wray.o \
	wrdpack.o \
	experimenter.o \
	errorc.o \
	supersnk.o \
	get_phantom.o \
	create_phantom.o \
	projection.o \
	recon.o \
	analysis.o \
	blanks.o \
	getfom.o \
	analyze.o \
	get_iter_flag.o \
	read_eval_phantom1.o \
	stru_acc.o \
	read_eval_recon1.o \
	hit_ratio.o \
	getiters.o \
	pointwse.o \
	read_eval_recon2.o \
	read_eval_recon3.o \
	analyze2.o \
	signif1.o \
	read_fomfile.o \
	user_fom1.o \
	user_fom2.o \
	user_fom3.o \
	user_fom4.o \
	user_fom5.o \
	get_seed.o \
	check_if_iroi.o 
#
LIBS = \
	-L$(DIGLIBDIR) \
	-L$(XERCESLIBDIR) \
	-l$(DIGFILELIB) \
	-l$(DIGFILESNARKLIB) \
	-l$(XERCESLIB) \
	-l$(DIGRANDLIB) \
	-lm

######################################
# setings for testing
#LIBS=/usr/lib/libm.a 
#FLAGS= -ffloat-store -O0 -DFFCOMPARE
######################################

ALL: snark14 libsnark14.a

%.o : $(SRCDIR)/%.cpp
	$(CXX) $(CXXFLAGS) -c $(INCLUDEDIR) $< -o $@
%.o : $(SRCDIR)/%.c
	$(CC) $(CFLAGS) -c  $(INCLUDEDIR)  $< -o $@

snark14: $(OBJ)
	$(CXX) $(LDFLAGS) $(OBJ) -o $(OUTDIR)/snark14 $(LIBS)

libsnark14.a: $(OBJ)
	ar -rc $(LIBDIR)/libsnark14.a $(OBJ)
	ranlib $(LIBDIR)/libsnark14.a

clean:
	rm $(OBJ); rm $(OUTDIR)/snark14

