/*
***********************************************************
$SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
$HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/bldlst.cpp $
$LastChangedRevision: 85 $
$Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
$Author: agulati $
***********************************************************

 THIS SUBROUTINE COMPUTES THE MAXIMAL SIZE OF THE LIST AND WEIGHT
 ARRAYS NEEDED BY RAY AND WRAY.  IT ALLOCATES
 THE MAXIMUM OF THESE VALUES FOR THE LIST AND WEIGHT ARRAYS.
*/

#include <cstdlib>     
#include <cstdio>
#include <cmath>

#include "blkdta.h"
#include "geom.h"
#include "uiod.h"
#include "bldlst.h"
                                         
void bldlst(INTEGER** lbase, REAL** wbase)
{  
  INTEGER npts;

  npts = 2 * GeoPar.nelem;
   
  if(GeoPar.strip) {
    npts = 2 * GeoPar.nelem * (INTEGER)ceil(GeoPar.pinc / GeoPar.pixsiz);  // bug82 - swr - 2/20/05
  }

  *lbase = new INTEGER[npts];
  *wbase = new REAL[npts];
}      

