/*      
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/creaer.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 THIS SUBROUTINE HANDLES THE ERRORS ENCOUNTERED IN INPUT DATA
 PHASE FOR CREATR
 */

#include <cstdlib>
#include <cstdio>

#include "blkdta.h"
#include "creacm.h"
#include "uiod.h"

#include "int2str.h"      

#include "creaer.h"

void creaer(INTEGER code)
{
	INTEGER word;

	Creacm.erflag = TRUE;
	word = code;
	if ((code < 1) || (code > 27))
		code = 2;

	switch (code)
	{

	case 1:
		fprintf(output,
				"\n **** only one create/picture/projection command allowed");
		break;

	case 2:
		fprintf(output, "\n **** keyword -  %s  - missing", int2str(word));
		break;

	case 3:
		fprintf(output, "\n **** 0 or more than 7 energy levels");
		break;

	case 4:
		fprintf(output,
				"\n **** percentage of photons is negative or total is not = 100");
		break;

	case 5:
		fprintf(output,
				"\n **** unknown object type - not ellipse, rectangle, triangle, sector or segment");
		break;

	case 6:
		fprintf(output,
				"\n **** value for semiaxes for object is negative, 0 or too small");
		break;

	case 7:
		fprintf(output, "\n **** scale factor is too small or zero");
		break;

	case 8:
		fprintf(output,
				"\n **** value for nave1 or nave2 is negative, zero, or even; or nave2 > 13");
		break;

	case 9:
		fprintf(output, "\n **** value for nelem is negative, 0 or even");
		break;

	case 10:
		fprintf(output,
				"\n **** negative, zero or too small a value for pixsiz or pinc");
		break;

	case 11:
		fprintf(output, "\n **** inconsistent geometry specification");
		break;

	case 12:
		fprintf(output,
				"\n **** uniform or variable spacing must be specified");
		break;

	case 13:
		fprintf(output, "\n **** nrays is negative, zero or even");
		break;

	case 14:
		fprintf(output, "\n **** number of projections is negative or zero");
		break;

	case 15:
		fprintf(output,
				"\n **** ray calculation option must be user or program");
		break;

	case 16:
		fprintf(output, "\n **** calibration type out of range");
		break;

	case 17:
		fprintf(output,
				"\n **** scattering peak or width is negative, zero or too small");
		break;

	case 18:
		fprintf(output,
				"\n **** unknown noise type or keyword or seed/back missing");
		break;

	case 19:
		fprintf(output,
				"\n **** aperture weight given is negative, or sum of aperture weights is negative or zero");
		break;

	case 20:
		fprintf(output, "\n **** equal spacing but only 1 projection");
		break;

	case 21:
		fprintf(output,
				"\n **** mono or polychromatic spectrum must be specified");
		break;

	case 22:
		fprintf(output, "\n");
		break;

	case 23:
		fprintf(output,
				"\n **** picture description must preceed projection data");
		break;

	case 24:
		fprintf(output,
				"\n **** test picture not present - pseudo data not created");
		break;

	case 25:
		fprintf(output,
				"\n **** unexpected end of file or line, insufficient data");
		break;

	case 26:
		fprintf(output,
				"\n **** quantum mean or calibration is negative or too small");
		break;

	case 27:
		fprintf(output,
				"\n **** value of multiplicative noise mean is too small");
		break;
	};

	fprintf(output, "\n **** program aborted\n");
	exit(-1);
}
