/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_bckwrd.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 PURPOSE: PERFORM BACKTRANSFORM THEN CALL SUBROUTINE FTFILL TO
 STORE THE VALUES IN THE ARRAY RECON
 */

#include <cstdio>

#include "blkdta.h"
#include "geom.h"
#include "fourie.h"
#include "uiod.h"
#include "second.h"

#include "foru.h"

void foru_class::bckwrd(REAL* recon)
{
	REAL tback;
	INTEGER n1;
	INTEGER n3;
	REAL* nr;
	REAL t1;
	REAL fact;
	INTEGER invdir;
	REAL t2;
	REAL sum;
	INTEGER k;
	REAL ave;
	REAL adj;

	tback = 0.0;
	n1 = Fourie.nsize2;
	n3 = Fourie.nsize2 + 2;
	nr = Fourie.nfrpln;

	// PERFORM BACKTRANSFORM
	second(&t1);
	fact = (REAL) 1.0 / (GeoPar.pixsiz * GeoPar.pixsiz);
	invdir = -1;
	fft(Fourie.nfrpln, Fourie.nback, invdir, fact);
	second(&t2);
	tback = t2 - t1;
	fprintf(output, "\ntime for backtransform :           %10.3f  seconds   ", tback); // changed precision to three digits - swr 1/21/06
	nr = Fourie.nfrpln;


	// CALL FTFILL TO PUT THE NUMBERS IN RECON
	ftfill(recon, Fourie.nfrpln, Fourie.nsize2);


	// ADJUST THE NUMBERS IN RECON SO THAT THE AVERAGE DENSITY IS AVEDEN
	sum = 0.0;
	for (k = 0; k < GeoPar.area; k++)
	{
		sum += recon[k];
	}

	ave = sum / GeoPar.area;
	adj = GeoPar.aveden - ave;
	for (k = 0; k < GeoPar.area; k++)
	{
		recon[k] += adj;
	}

	return;
}
