/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_forwrd.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 FORWRD: FORWARD
 PURPOSE: READ IN PROJECTIONS , TRANSFORM THEN INTERPOLATE
 */

#include <cstdio>
#include "blkdta.h"
#include "geom.h"
#include "fourie.h"
#include "uiod.h"
#include "second.h"

#include "foru.h"

void foru_class::forwrd()
{
	REAL tforw;
	REAL tintr;
	REAL* nold;
	REAL* new1;
	REAL t1;
	REAL phi1;
	REAL dphi1;
	REAL t2;
	INTEGER np;
	REAL phi2;
	REAL dphi2;
	REAL t3;
	REAL* kdum;
	INTEGER kh;
	INTEGER k;

	tforw = 0.0;
	tintr = 0.0;

	// READ IN 1ST PROJECTION AND TRANSFORM
	nold = Fourie.nproj1;
	new1 = Fourie.nproj2;
	second(&t1);
	prjtrn(0, nold, &phi1, &dphi1);
	second(&t2);
	tforw += t2 - t1;

	for (np = 1; np < GeoPar.prjnum; np++)
	{

		// READ IN NEXT PROJECTION , TRANSFORM THEN INTERPOLATE

		second(&t1);
		prjtrn(np, new1, &phi2, &dphi2);
		if (Fourie.iflg == 1)
			return;
		second(&t2);
		tforw += t2 - t1;
		intrpl(phi1, phi2, dphi1, dphi2, nold, new1);
		second(&t3);
		tintr += t3 - t2;

		kdum = new1;
		new1 = nold;
		nold = kdum;
		phi1 = phi2;
		dphi1 = dphi2;

	}

	// READ IN 1ST PROJECTION AGAIN, INTERPOLATE USING LAST AND 1ST PROJS

	second(&t1);
	prjtrn(0, new1, &phi2, &dphi2);
	if (Fourie.iflg == 1)
		return;
	second(&t2);
	tforw += t2 - t1;
	intrpl(phi1, phi2, dphi1, dphi2, nold, new1);
	second(&t3);
	tintr += t3 - t2;

	if (!GeoPar.par)
	{
		kh = Fourie.nsize2 * (Fourie.nsize2 + 2);

		for (k = 2; k < kh; k++)
		{
			Fourie.nfrpln[k] /= 2.0;
		}
	}

	fprintf(output, "\ntime for projection transforms :   %10.3f  seconds    ", tforw); // changed precision to three digits - swr 1/21/06
	fprintf(output, "\ntime for interpolations :          %10.3f  seconds    ", tintr); //ditto
	return;
}
