/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/lines.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#include <cstdio>

#include "blkdta.h"

#include "lines.h"

void lines(REAL* a, REAL* b, INTEGER nrow, INTEGER mcol, REAL scale, INTEGER lineno, INTEGER* linumb, FILE* file)
{
	int i;
	INTEGER one;

	REAL linout[12];

	INTEGER linno3;
	INTEGER irow;
	INTEGER jcolum;
	INTEGER index;

	fprintf(file, "\n     scaling factor = %10.5f\n", scale);
	fprintf(file, "\n column =            %4i", linumb[0]);
	for (i = 1; i < lineno; i++)
	{
		fprintf(file, "                             %4i", linumb[i]);
	}

	fprintf(file, "\n row  ");
	for (i = 0; i < lineno; i++)
	{
		fprintf(file, "  original   estimate difference ");
	}

	linno3 = 3 * lineno;
	for (irow = 0; irow < nrow; irow++)
	{
		one = 0;
		for (jcolum = 0; jcolum < lineno; jcolum++)
		{
			index = (irow) * mcol + linumb[jcolum];


			linout[one] = scale * a[index];
			linout[one + 1] = scale * b[index];
			linout[one + 2] = linout[one + 1] - linout[one];

			one += 3;
		}
		fprintf(file, "\n%4i ", irow);
		for (i = 0; i < linno3; i++)
		{
			fprintf(file, "  %9.5f", linout[i]);
		}
	}
	fprintf(file, "\n\n");

	return;
}
