/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/quad_badsmos.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 THIS ROUTINE PERFORMS THE FOUR DIFFERENT SMOOTHING PROCEDURES
 USED IN THE QUADRATIC OPTIMIZATION ALGORITHM FOR BLOB RECONSTRUCTIONS.//changed . hstau

 */

#include <cstdio>

#include "blkdta.h"
#include "geom.h"

#include "blob.h"
#include "quad.h"

//pragma message( "to fix!" )
/// fix indexes 1 -> 0

void quad_class::badsmos(REAL* x, INTEGER m, REAL w1, REAL w2, INTEGER bcon)
{
	BOOLEAN snar, sajc;

	static const INTEGER hsnar = CHAR2INT('s', 'n', 'a', 'r');
	static const INTEGER hsajc = CHAR2INT('s', 'a', 'j', 'c');
	static const INTEGER hkami = CHAR2INT('k', 'a', 'm', 'i');

	INTEGER kami;
	//INTEGER n,    // number of rows
	INTEGER H;    // number of rows
	INTEGER M;   // number of columns
	INTEGER m1;  // Blob.M-1
	INTEGER m2;  //Blob.M+1
	INTEGER h1;  //Blob.H-1

	REAL weit4;
	REAL weit6;
	//REAL weit9;
	REAL weit3;
	REAL weit5;
	REAL weit7;

	REAL w3 = w2;
	REAL* ip = NULL;
	REAL* in = NULL;  //wei 3/2005
	//REAL* ipf;         //wei 3/2005
	//REAL lb, rb;
	REAL lt, rt;
	INTEGER j;
	INTEGER i;
	INTEGER l1;
	INTEGER ln;
	INTEGER k;
	REAL* ipin;
	INTEGER li;
	INTEGER l;

	INTEGER area;
	INTEGER kpr;

	area = Blob.area;

	// FOR THE KAMI METHOD THE ROUTINE IS EXECUTED TWICE

	kami = 1;

	// INDEX PARAMETERS

	//n = GeoPar.nelem;
	H = Blob.H;
	M = Blob.M;
	//n1 = n - 1;
	//n2 = n + 1;
	h1 = H - 1;
	m1 = M - 1;
	m2 = M + 1;

	snar = FALSE;
	sajc = FALSE;
	if (bcon == hsnar)
		snar = TRUE;
	if (bcon == hsajc)
		sajc = TRUE;
	if (snar)
	{
		weit4 = (REAL) (w1 + w2 + 2.0 * w3);
		weit6 = weit4 + w2 + w3;
		//weit9 = (REAL) (weit6 + w2 + 2.0 * w3);
		weit3 = (REAL) (w1 + w2 + w3);
		weit5 = weit3 + w2 + w3;
		weit7 = (REAL) (weit5 + 2.0 * w3);

	}
	// ALLOCATE WORKING SPACE

	//ip = new REAL[n];
	ip = new REAL[M];

	//in = new REAL[n];
	in = new REAL[M];

	for (;;)
	{
		for (j = 0; j < m; j++)
		{

			// SMOOTH FIRST ROW OF PICTURE

			in[Blob.pr] = x[Blob.pr];
			in[m1 - Blob.pr] = x[m1 - Blob.pr];

			if (!sajc)
			{
				if (Blob.pr == 0)
				{
					x[0] = w1 * x[0] + w2 * x[2] + w3 * x[m2];
					if (snar)
						x[Blob.pr] /= weit3; //x[0] /= weit4;
				}

				else
				{
					x[1] = w1 * x[1] + w2 * x[3] + w3 * x[Blob.pr + m2]
							+ w3 * x[M];
					if (snar)
						x[Blob.pr] /= weit4; //x[0] /= weit4;
				}
				for (i = Blob.pr + 2; i < m1 - Blob.pr; i += 2)
				{
					in[i] = x[i];
					x[i] = w1 * x[i] + w2 * (in[i - 2] + x[i + 2])
							+ w3 * (x[m1 + i] + x[m2 + i]);

					if (snar)
						x[i] /= weit5; //x[i] /= weit6;
				}
				if (Blob.pr == 0)
				{
					x[m1] = w1 * x[m1] + w2 * in[m1 - 2] + w3 * x[m1 + m1];
					//if(snar) x[n-1] /= weit4;
					if (snar)
						x[m1] /= weit3;
				}
				else
				{
					x[m1 - 1] = w1 * x[m1 - 1] + w2 * in[m1 - 3]
							+ w3 * x[m1 - 1 + m1] + w3 * x[m1 - 1 + m2];
					if (snar)
						x[m1 - 1] /= weit4;
				}

			}
			else
			{
				k = 0;
				if (Blob.pr == 0)
				{
					REAL a1 = x[0];
					REAL a2 = (x[0] + x[m2] + x[2 * M]) / 3.0;
					x[0] = (REAL) (w1 * x[0] + w2 * (a1 + x[2])
							+ w3 * (x[0] + (x[0] + x[2]) / 2.0 + a2 + x[m2]));
				}
				else
				{
					REAL a1 = (x[1] + x[M]) / 2.0;
					x[1] = (REAL) (w1 * x[1] + w2 * (a1 + x[3])
							+ w3
									* (x[1] + (x[1] + x[3]) / 2.0 + x[M]
											+ x[M + 2]));
				}

				for (i = Blob.pr + 2; i < m1 - Blob.pr; i += 2)
				{
					in[i] = x[i];
					x[i] = w1 * x[i] + w2 * (in[i - 2] + x[i + 2]) + w3 * (x[m1 + i] + x[m2 + i] + x[i] + (in[i - 2] + x[i + 2]) / 2.0);

				}

				// bug 191 - SAJC smoothing - swr - 12/17/05
				if (Blob.pr == 0)
				{
					REAL a1 = x[m1];
					REAL a2 = (x[m1] + x[m1 + m1] + x[2 * M + m1]) / 3.0;
					x[m1] = (REAL) (w1 * x[m1] + w2 * (in[m1 - 2] + a1) + w3 * (x[m1] + (x[m1] + in[m1 - 2]) / 2.0 + x[m1 + m1] + a2));
				}
				else
				{
					REAL a1 = (x[m1 - 1] + x[m1 - 1 + m2]) / 2.0;
					x[m1 - 1] = (REAL) (w1 * x[m1 - 1] + w2 * (in[m1 - 3] + a1) + w3 * ((in[m1 - 3] + x[m1 - 1]) / 2.0 + x[m1 - 1] + x[m1 + m1 - 1] + x[m1 + m1 + 1]));
				}

			}

			for (k = 1; k < h1; k++)
			{
				ipin = in;
				in = ip;
				ip = ipin;
				kpr = (k - Blob.pr) % 2;
				l = k * M;
				l1 = l + kpr;
				ln = l1 + m1 - 2 * kpr;

				lt = in[kpr];
				rt = in[m1 - kpr];
				in[kpr] = x[l1];
				in[m1 - kpr] = x[ln];

				x[l1] = w1 * x[l1] + w2 * x[l1 + 2];

				if (kpr == 0)
				{
					x[l1] += w3 * (ip[1] + x[l1 + m2]);
				}
				else
				{
					x[l1] += w3 * (ip[0] + ip[2] + x[l1 + m2] + x[l1 + m1]);
				}
				if (sajc)
				{
					// bug 191 - SAJC smoothing - swr - 12/17/05
					if (kpr == 0)
					{
						REAL a1;
						if (k > 1)
							a1 = (lt + ip[1] + in[0]) / 3.0;
						else
							a1 = (ip[1] + in[0]) / 2.0;
						REAL a2 = in[0];
						REAL a3;
						if (k < h1 - 1)
							a3 = (in[0] + x[l1 + m2] + x[l1 + 2 * M]) / 3.0;
						else
							a3 = (in[0] + x[l1 + m2]) / 2.0;
						x[l1] += w2 * a2 + w3 * (a1 + a3);
					}
					else
					{
						REAL a1 = (ip[0] + in[1] + x[l1 + m1]) / 3.0;
						x[l1] += w2 * a1;
					}
				}

				if (snar)
				{
					if (kpr == 0)
						x[l1] /= weit5;
					else
						x[l1] /= weit6;
				}
				for (i = 2 + kpr; i < m1 - kpr; i += 2)
				{    //next point on the same row
					li = k * M + i;
					in[i] = x[li];
					x[li] = w1 * x[li] + w2 * (in[i - 2] + x[li + 2]) + w3 * (ip[i - 1] + ip[i + 1] + x[li + m1] + x[li + m2]);

					if (snar)
						x[li] /= weit7;
				}
				x[ln] = w1 * x[ln] + w2 * in[m1 - 2 - kpr];

				if (kpr % 2 == 0)
				{
					x[ln] += w3 * (ip[m1 - 1] + x[ln + m1]);
				}
				else
				{
					x[ln] += w3
							* (ip[m1 - 2] + x[ln + m1] + x[ln + m2] + ip[m1]);
				}

				if (snar)
				{
					if (kpr == 0)
						x[ln] /= weit4;
					else
						x[ln] /= weit6;
				}

				if (sajc)
				{
					// bug 191 - SAJC smoothing - swr - 12/17/05
					if (kpr == 0)
					{
						REAL a1;
						if (k > 1)
							a1 = (rt + in[m1] + ip[m1 - 1]) / 3.0;
						else
							a1 = (in[m1] + ip[m1 - 1]) / 2.0;
						REAL a2 = in[m1];
						REAL a3;
						if (k < h1 - 1)
							a3 = (in[m1] + x[ln + m1] + x[ln + 2 * M]) / 3.0;
						else
							a3 = (in[m1] + x[ln + m1]) / 2.0;
						x[ln] += w2 * a2 + w3 * (a1 + a3);
					}
					else
					{
						REAL a1 = (in[m1 - 1] + ip[m1] + x[ln + m2]) / 3.0;
						x[ln] += w2 * a1;
					}
				}
			}

			// SMOOTH LAST ROW

			// IN LAST ROW CHANGE ROLE OF IN AND IP

			l1 = h1 * M + Blob.pr;
			ln = l1 + m1 - 2 * Blob.pr;
			l = h1 * M;
			lt = ip[Blob.pr];
			rt = ip[m1 - Blob.pr];

			ip[Blob.pr] = x[l1];

			if (!sajc)
			{
				if (Blob.pr == 0)
				{
					x[l1] = w1 * x[l1] + w2 * x[l1 + 2] + w3 * (in[1]);
				}
				else
				{
					x[l1] = w1 * x[l1] + w2 * x[l1 + 2] + w3 * (in[0] + in[2]);
				}

				if (snar)
				{
					if (Blob.pr == 0)
						x[l1] /= weit3;
					else
						x[l1] /= weit4;
				}

				for (i = 2 + Blob.pr; i < m1 - Blob.pr; i += 2)
				{
					li = l + i;
					ip[i] = x[li];

					x[li] = w1 * x[li] + w2 * (ip[i - 2] + x[li + 2])
							+ w3 * (in[i - 1] + in[i + 1]);

					if (snar)
						x[li] /= weit5;
				}
				if (Blob.pr == 0)
				{
					x[ln] = w1 * x[ln] + w2 * ip[m1 - 2] + w3 * in[m1 - 1];
				}
				else
				{
					x[ln] = w1 * x[ln] + w2 * ip[m1 - 3]
							+ w3 * (in[m1 - 2] + in[m1]);
				}

				if (snar)
				{
					if (Blob.pr == 0)
						x[ln] /= weit3;
					else
						x[ln] /= weit4;
				}
			}
			else
			{
				// bug 191 - SAJC smoothing - swr - 12/17/05
				if (Blob.pr == 0)
				{
					REAL a1 = x[l1];
					REAL a2 = (x[l1] + lt + in[1]) / 3.0;
					x[l1] = w1 * x[l1] + w2 * (x[l1 + 2] + a1)
							+ w3
									* (a2 + in[1] + x[l1]
											+ (x[l1] + x[l1 + 2]) / 2.0);
				}
				else
				{
					REAL a1 = (x[l1] + in[0]) / 2.0;
					x[l1] = w1 * x[l1] + w2 * (a1 + x[l1 + 2]) + w3 * (in[0] + in[2] + x[l1] + (x[l1] + x[l1 + 2]) / 2.0);
				}

				for (i = 2 + Blob.pr; i < m1 - Blob.pr; i += 2)
				{
					li = l + i;
					ip[i] = x[li];

					x[li] = w1 * x[li] + w2 * (ip[i - 2] + x[li + 2])
							+ w3
									* (x[li] + 0.5 * ip[i - 2] + 0.5 * x[li + 2]
											+ in[i - 1] + in[i + 1]);

				}

				// bug 191 - SAJC smoothing - swr - 12/17/05
				if (Blob.pr == 0)
				{
					REAL a1 = x[ln];
					REAL a2 = (x[ln] + in[m1 - 1] + rt) / 3.0;
					x[ln] = w1 * x[ln] + w2 * (ip[m1 - 2] + a1) + w3 * (a2 + in[m1 - 1] + (ip[m1 - 2] + x[ln]) / 2.0 + x[ln]);
				}
				else
				{
					REAL a1 = (x[ln] + in[m1]) / 2.0;
					x[ln] = w1 * x[ln] + w2 * (ip[m1 - 3] + a1) + w3 * (in[m1 - 2] + in[m1] + (ip[m1 - 3] + x[ln]) / 2.0 + x[ln]);
				}
			}
		}

		if ((bcon != hkami) || (kami == 2))
			goto L17;

		// PREPARE FOR SECOND ROUND FOR KAMI

		kami = 2;

		for (i = 0; i < M; i++)
		{
			x[i] = 0.0;
			x[l + i] = 0.0;
		}

		l1 = 0;
		ln = m1;

		for (i = 1; i < h1; i++)
		{
			l1 = l1 + M;
			ln = ln + m1;
			x[l1] = 0.0;
			x[ln] = 0.0;
		}
	}

	L17:
	// delete[] ipf;  // bug 92 - Lajos - 03/02/2005      wei/2005
	delete[] ip;
	delete[] in;   // wei 3/2005

	return;
}
