/** @file displayprojection.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef DISPLAYPROJECTION_H
#define DISPLAYPROJECTION_H

#include "variables.hpp"
#include "displaywidget.hpp"
#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QLineEdit;
class QPushButton;
class QRadioButton;
class QSlider;
class QListBox;
class QImage;
class QPixmap;
class QScrollView;

class displayprojection : public QDialog
{ 
    Q_OBJECT

public:
    displayprojection( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0, int x = 0, int y = 0 );
    ~displayprojection();

    QString windowname;
    QString imagename;
    double **proj;
    double maxval,minval;
    double lowthreshold,highthreshold;
    double range;
    int zoomval;
    int maxzoom;
    displayWidget* displaywidget;
    QLabel* zoomlabel;
    QSlider* zoomslider;
    QLineEdit* zoom;
    QPushButton* setzoombutton;
    QRadioButton* globalthresholdbutton;
    QRadioButton* differencebutton;
    QRadioButton* intensitybutton;
    QLabel* lowthreshlabel;
    QSlider* lowthreshslider;
    QLineEdit* lowthresh;
    QPushButton* setlowthreshbutton;
    QLabel* highthreshlabel;
    QSlider* highthreshslider;
    QLineEdit* highthresh;
    QPushButton* sethighthreshbutton;
    QLabel* pixelposlabel;
    QLineEdit* pixelpos;
    QLabel* pixelvaluelabel;
    QLineEdit* pixelvalue;
    QPushButton* profilebutton;
    QPushButton* linesbutton;
    QPushButton* savebutton;
    QPushButton* closebutton;
    QScrollView* scrollv;
public slots:
    void updateClickedPixel(int cx,int cy);
    void updateZoom();
    void updateZoomslider();
    void intensity();
    void updateLowthresh();
    double getLowthresh();
    void updateLowthreshslider();
    void updateHighthresh();
    double getHighthresh();
    void updateHighthreshslider();
    void resetscroll();
    void resetImage();
    void resetImageRange();
    void callLines();
    void saveImage();
};

#endif // DISPLAYPROJECTION_H
