/** @file linesimages.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef LINESIMAGESWINDOW_H
#define LINESIMAGESWINDOW_H

#include <qvariant.h>
#include <qdialog.h>
#include <qbuttongroup.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QComboBox;
class QGridLayout; 
class QFrame;
class QLabel;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QPushButton;
class QRadioButton;

class linesimageswindow : public QDialog
{ 
    Q_OBJECT

public:
    linesimageswindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~linesimageswindow();

    double minval;
    double maxval;
    int *selectedimages;
    bool selected;
    QListBox* rowcolbox;
    QRadioButton* phantombutton;
    QLineEdit* line1;
    QLineEdit* line2;
    QLineEdit* line3;
    QLineEdit* line4;
    QLineEdit* title;
    //    QComboBox* subtitle;
    //    QComboBox* gridstyle;
    QLineEdit* xaxis;
    QLineEdit* yaxis;
    QLineEdit* minx;
    QLineEdit* maxx;
    QLineEdit* miny;
    QLineEdit* maxy;
    QLabel* label1;
    QLabel* label2;
    QLabel* label3;
    QLabel* label4;
    QLabel* titlelabel;
    //    QLabel* subtitlelabel;
    //    QLabel* gridstylelabel;
    QLabel* xaxislabel;
    QLabel* yaxislabel;
    QLabel* minxlabel;
    QLabel* maxxlabel;
    QLabel* minylabel;
    QLabel* maxylabel;
    QFrame* Line3;
    QPushButton* showbutton;
    QPushButton* imagesbutton;
    QPushButton* cancelbutton;
    // jk 1/13/2009 adding grayScale option for graphs
    QButtonGroup* colorbuttongroup;
    QRadioButton* grayScaleButton;
    QRadioButton* colorButton;
  public slots: 
    void updateXAxis(int i);
    void callSelectImages();
    int* getSelectedImages();
    int getLinetype();
    int getLine1();
    int getLine2();
    int getLine3();
    int getLine4();
    QString getTitle();
    //    int getSubtitle();
    //    int getGridstyle();
    QString getXAxis();
    QString getYAxis();
    int getMinX();
    int getMaxX();
    double getMinY();
    double getMaxY();
    bool isPhantomChecked();
    void checkAndAccept();
    // jk 1/13/2009 adding grayScale option for graphs
    bool isGrayScaleChecked();
};

#endif // LINESIMAGESWINDOW_H
